Attribute VB_Name = "api"
Global fPath As String
Global file() As Byte
Global pageChanges() As String
Global SelStart As Long
Global SelLength As Long
Global LastEditOffset As Long
Global Dirty As Boolean

Function GetByteFromGrid(x, y) As String
    'If x = Empty Then Exit Function 'used to indicate click out of bounds
    'rember file() = 1 based ! editor = 0 based !
    Dim ret As String
    offset = GetOffsetFromGrid(x, y) + 1
    ret = Hex(file(offset))
    GetByteFromGrid = IIf(Len(ret) = 1, "0" & ret, ret)
End Function

Function GetOffsetFromGrid(x, y) As Long
    Dim offset As Long
    a = (x - 54) / 18                '54 points (9chars) before hex data starts
    topoffset = GetTopOffset()       'what page are we viewing?
    b = topoffset + ((y / 9) * 16)   '16 characters per line each 9 y points = one line
    offset = b + a                   'editor view is 0 based ! file() = 1 base
    GetOffsetFromGrid = offset
End Function

Function GetGridFromOffset(offset)
    topoffset = GetTopOffset()
    If offset > (topoffset + &H200) Then MsgBox "Ughh offset: " & Hex(offset) & " is off page!": Exit Function
    linesdown = (offset - topoffset) / 16
    x = ((offset Mod 16) * 18) + 54
    y = linesdown * 9
    Dim ret()
    push ret(), SnapX(x)
    push ret(), snapY(y)
    GetGridFromOffset = ret()
End Function

Function GetCharGridFromOffset(offset)
    topoffset = GetTopOffset()
    If offset > (topoffset + &H200) Then MsgBox "Ughh sel off page?!": Exit Function
    linesdown = (offset - topoffset) / 16
    x = ((offset Mod 16) * 6) + 360
    y = linesdown * 9
    Dim ret()
    push ret(), x
    push ret(), snapY(y)
    GetCharGridFromOffset = ret()
End Function

Function GetOffsetFromEitherGrid(x, y) As Long
    'wrapped again because i have 3 versions to correct ugh
    Dim offset As Long
    If x > 350 Then offset = CLng(GetOffsetFromCharGrid(x, y)) _
    Else offset = GetOffsetFromGrid(x, y)
    GetOffsetFromEitherGrid = IIf(offset < UBound(file), offset, -1)
End Function

Function GetOffsetFromCharGrid(x, y)
    topoffset = GetTopOffset()
    modulus = (x - 360) / 6
    linesdown = y / 9
    base = topoffset + (linesdown * 16)
    GetOffsetFromCharGrid = base + modulus
End Function

Sub ChangeByteFromGrid(x, y, hexStrNewVal)
    file(GetOffsetFromGrid(x, y) + 1) = CByte("&H" & hexStrNewVal)
End Sub

Sub ChangeByteFromOffset(offset, hexstrValue)
    file(offset + 1) = CByte("&h" & hexstrValue)
End Sub

Sub OverWrite(x, y, Data, Optional bc = -1, Optional fc = -1)
    With frmHexEdit.picDisp
        If x = Empty Then Exit Sub
        orig = .forecolor
         c = Array("M", "Z", "T") 'these 3 will overwrite all areas of block
         For i = 0 To 2
            .CurrentX = x
            .CurrentY = y
            .forecolor = IIf(bc = -1, .BackColor, bc)
            frmHexEdit.picDisp.Print String(Len(Data), c(i))
         Next
        .CurrentX = x
        .CurrentY = y
        .forecolor = IIf(fc = -1, orig, fc)
        frmHexEdit.picDisp.Print Data
        .forecolor = orig
    End With
End Sub

Sub OverWriteOffsetRange(startAt, stopAt, Optional forecolor = -1, Optional bkcolor = -1, Optional incSelLength As Boolean = True)
    k = IIf(stopAt > startAt, 1, -1)
    SelLength = IIf(incSelLength, (stopAt - startAt) * k, -1)
    Dim ret()
    For i = startAt To stopAt Step 1 * k
        ret = GetGridFromOffset(i)
        OverWrite ret(0), ret(1), GetByteFromGrid(ret(0), ret(1)) & " ", bkcolor, forecolor
    Next
End Sub

Function snapY(it)
    snapY = RoundUp(it, 9)
End Function

Function GetTopOffset()
    sv = frmHexEdit.scroll.value     'bastard overflows on high offsets cause of this ! even when just multiplying and not savign to it !
    GetTopOffset = sv * &H200        'scrolls at &h200 pages
End Function

Function SnapX(it)
    Dim x As Integer 'characters are fixed at 6 points wide..hexbytes=2 +space
    x = CInt(it)     ' > 360 = char edit mode
    If x < 54 Or (x > 340 And x < 360) Then Exit Function 'x=empty = marker for some actions
    If x < 340 Then SnapX = RoundUp(x, 18) Else SnapX = RoundUp(x, 6)
End Function

Sub RemberChange(offset)
    'array has as many elements as there are pages
    'each element = comma delimited list of offsets changed
    pageChanges(frmHexEdit.scroll.value) = pageChanges(frmHexEdit.scroll.value) & offset & ","
End Sub

Sub ShowChanges()
    If pageChanges(frmHexEdit.scroll.value) = Empty Then Exit Sub
    t = Split(pageChanges(frmHexEdit.scroll.value), ",")
    For i = 0 To UBound(t) - 1
        SelectByte CLng(t(i)) 'boy is that clng necessary! through in 5min bug hunt cause of datatype dont even mumble option explicit bug hunting is half the ughh fun :P
    Next
End Sub

Sub ShowSelections()
    If SelStart < 0 Then Exit Sub
    If OffsetFallsOnPage(SelStart) Or _
       OffsetFallsOnPage(SelStart + SelLength) Then
        If SelLength > 0 Then
            SelectByteRange SelStart, SelStart + SelLength, , , False
        Else
            SelectByte SelStart
        End If
    End If
End Sub

Function OffsetFallsOnPage(offset) As Boolean
    topoffset = GetTopOffset()
    If offset > topoffset And offset < topoffset + &H200 Then OffsetFallsOnPage = True
End Function

Sub SelectByte(ByVal offset, Optional selected = True, Optional char2 = True, Optional SetStart = True)
    If selected Then SelStart = IIf(SetStart, offset, SelStart) Else SelStart = -1
    byteval = HexString(file(), offset + 1)
    If selected Then bc = vbYellow: fc = vbBlack Else bc = -1: fc = -1
    tmp = GetGridFromOffset(offset)
    OverWrite tmp(0), tmp(1), byteval & " ", bc, fc
    If char2 Then
        tmp = GetCharGridFromOffset(offset)
        OverWrite tmp(0), tmp(1), GetDisplayChar(byteval), bc, fc
    End If
End Sub

Sub SelectByteRange(ByVal startAt, ByVal stopAt, Optional selected = True, Optional char2 = True, Optional setLen = True)
    k = IIf(stopAt > startAt, 1, -1)
    topoffset = GetTopOffset()
    If setLen Then SelLength = stopAt - startAt * k
    If startAt < topoffset Then startAt = topoffset
    If stopAt > topoffset + &H200 Then stopAt = topoffset + &H200
    For i = startAt To stopAt Step 1 * k
        SelectByte i, selected, char2, False
    Next
End Sub

Sub EditByte(offset)
        With frmHexEdit
            SelectByte offset, , , False
            LastEditOffset = offset
            tmp = GetGridFromOffset(offset)
            .txtEdit.Move tmp(0), tmp(1) + .picDisp.Top + 1, 15, 9
            .txtEdit = HexString(file(), offset + 1)
            .txtEdit.Visible = True
            .txtEdit.SetFocus
        End With
End Sub

Sub EditChar(x, y)
    With frmHexEdit
        offset = GetOffsetFromCharGrid(x, y)
        LastEditOffset = offset
        SelectByte offset 'this sets selstart
        .txtChr.Move x, y + .picDisp.Top + 1, 6, 9
        .txtChr = GetDisplayChar(HexString(file(), offset + 1))
        .txtChr.Visible = True
        .txtChr.SetFocus
    End With
End Sub

